<script setup lang="ts">
import Flex from "@/components/atoms/container/Flex.vue";
import ExternalLink from "@/components/atoms/link/ExternalLink.vue";
import type Repository from "@/entities/Repository/Repository";
import SmallImg from "@/components/atoms/img/SmallImg.vue";
import Checkbox from "primevue/checkbox";
import InputText from "primevue/inputtext";
import Grid from "@/components/atoms/container/Grid.vue";
import {computed} from "vue";
import AutoCompleteBranch from "@/components/molecules/form/Branch/AutoCompleteBranch.vue";

const props = defineProps<{ repository: Repository, import?: Boolean, checkImportCallback?: Function }>()

const code = computed(() => {
  return props.repository?.code
});

const checked = computed({
  get: () => {
    return props.repository.isAlreadyImported || props.import;
  },
  set: (newValue: Boolean) => {
    if (props.checkImportCallback && !props.repository.isAlreadyImported) {
      props.checkImportCallback(newValue);
    }
  }
})

</script>

<template>
  <Flex class="gap-content items-center">
    <Checkbox
        :inputId="'import_' + code"
        :disabled="repository?.isAlreadyImported"
        :binary="true"
        v-model="checked"
    />
    <label :for="'import_' + code">
      <SmallImg :alt="repository.name" :src="repository.img"/>
    </label>
    <Grid class="grid-cols-6 gap-text">
      <InputText
          v-model="repository.name"
          class="col-span-2"
          minlength="5"
          maxlength="50"
          required
          :disabled="!checked"
      />
      <AutoCompleteBranch
          :repository="repository"
          v-model:branch="repository.mainBranch"
          class="col-span-2"
          title="Branche principale"
          placeholder="Branche principale"
          :required="true"
          :disabled="!checked"
      />
      <AutoCompleteBranch
          :required="false"
          :repository="repository"
          v-model:branch="repository.devBranch"
          class="col-span-2"
          title="Branche dev."
          placeholder="Branche dev."
          :disabled="!checked"
      />
      <ExternalLink :href="repository.link" class="ellipsis col-span-3" :title="repository.link">
        {{ repository.link }}
      </ExternalLink>
      <Flex class="col-span-2 gap-text items-center">
        <Checkbox
            :inputId="'create_new_version_' + code"
            v-model="repository.createBranchForNewVersion"
            :binary="true"
            :disabled="!checked"
        />
        <label :for="'create_new_version_' + code">Créer une branche par version</label>
      </Flex>
    </Grid>
  </Flex>
</template>